#pragma once

#include "mapped_file_object_interface.h"
#include "pager.h"

/* A pager abstraction for a file. */

class FilePager : public Pager, public MappedFileObject
{
public:
    fileid_t fileid;

    explicit FilePager(fileid_t fileid, PageMapper *mapper);

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<MappedFileObject *>(this); }

    /* Pager and mapped file methods. */

    virtual long map(unsigned long offset, l4_addr_t hot_spot, unsigned long flags, l4_snd_fpage_t *region);

    virtual long mmap(offset_t position, offset_t length, offset_t *start_pos, offset_t *end_pos, offset_t *data_end);
};

// vim: tabstop=4 expandtab shiftwidth=4
