#pragma once

#include "flexpage.h"
#include "memory.h"
#include "page_owner.h"
#include "page_queue.h"



/* A page collection. */

class Pages
{
protected:
    PageQueue _queue;
    Memory *_memory;

public:
    explicit Pages(Memory *memory);

    explicit Pages();

    Flexpage *remove();

    bool reserve(PageOwner *owner, Flexpage *flexpage);

    Flexpage *flexpage();

    void queue(PageOwner *owner, Flexpage *flexpage);

    void release(Flexpage *flexpage);
};

// vim: tabstop=4 expandtab shiftwidth=4
